<?php 
/**
 * Module Name: phpBB To PunBB
 * Version: 0.1
 * Author: PunBB.INFO
**/

if (!defined('FORUM')) die();

require $forum_url['pan_converter_modules'].'/'.$section.'/functions.php';

$errors = array();

if (isset($_POST['convert']) )
{
	$dump_name = $_POST['dump_name'];
	$prefix = forum_trim($_POST['prefix']);
	
	// !!! ОБЕРНУТЬ ВСЕ В ФУНКЦИЮ для защиты переменных
	if (file_exists(FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$dump_name))
		require FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$dump_name;
	
	if (isset($groups)) $phpbb_groups = $groups;
	if (isset($users)) $phpbb_users = $users;
	if (isset($posts)) $phpbb_posts = $posts;
	if (isset($topics)) $phpbb_topics = $topics;
	if (isset($forums)) $phpbb_topics = $forums;
	
	
	//Проверить список всех переменных
	if (!isset($phpbb_groups)) $errors[] = 'Table GROUPS not found!';
	else if (!isset($phpbb_users)) $errors[] = 'Table USERS not found!';
	else if (!isset($phpbb_posts)) $errors[] = 'Table POSTS not found!';
	else if (!isset($phpbb_topics)) $errors[] = 'Table TOPICS not found!';
	else if (!isset($phpbb_forums)) $errors[] = 'Table FORUMS not found!';
	
	
	if (empty($errors))
	{
		$forum_phpbb = array();
		$forum_phpbb['groups'] = array();
		$forum_phpbb['result'] = array();
		
		foreach ($phpbb_groups as $groups)
		{
			//ADMINISTRATOR
			if ($groups['group_id'] == 5)
				$group_id = 1;
			//GUESTS
			else if ($groups['group_id'] == 1)
				$group_id = 2;
			//REGISTERED
			else if ($groups['group_id'] == 2)
				$group_id = 3;
			//REGISTERED_COPPA
			else if ($groups['group_id'] == 3)
				$group_id = 3;
			//GLOBAL_MODERATORS
			else if ($groups['group_id'] == 4)
				$group_id = 4;
			//BOTS
			else if ($groups['group_id'] == 6)
				$group_id = 2;
			//NEWLY_REGISTERED
			else if ($groups['group_id'] == 7)
				$group_id = 2;
			else
				$group_id = 3;
			
			$forum_phpbb['groups'][$groups['group_id']] = $group_id;
		}
		
echo '<pre>';
//print_r($forum_phpbb['groups']);
echo '</pre>';
		
		$forum_phpbb['result']['users'] = 0;
		foreach ($phpbb_users as $users)
		{
			$query = array(
				'SELECT'	=> 'id',
				'FROM'		=> 'users',
				'WHERE'		=> 'id='.$users['user_id']
			);
			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$cur_uid = $forum_db->fetch_assoc($result);
			
			if (count($cur_uid) < 1)
			{
				$user_group_id = $forum_phpbb['groups'][$users['group_id']];
				
				if ($users['user_lang'] == 'en') $user_lang = 'English';
				else if ($users['user_lang'] == 'ru') $user_lang = 'Russian';
				else $user_lang = 'English';
					
				if (file_exists(FORUM_ROOT.'lang/'.$user_lang.'/index.php'))
					$user_lang = $user_lang;
				else
					$user_lang = 'English';
				
				$query = array(
					'INSERT'	=> 'id, group_id, username, password, salt, email, registered, registration_ip, last_visit, language, num_posts',
					'INTO'		=> 'users',
					'VALUES'	=> ''.$users['user_id'].', '.$user_group_id.', \''.$forum_db->escape($users['username']).'\', \''.$forum_db->escape($users['user_password']).'\', \''.$forum_db->escape($users['user_form_salt']).'\', \''.$forum_db->escape($users['user_email']).'\', '.$users['user_regdate'].', \''.$forum_db->escape($users['user_ip']).'\', '.$users['user_lastvisit'].', \''.$forum_db->escape($user_lang).'\', '.$users['user_posts'],
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);

				$forum_phpbb['result']['users']++;
echo '<pre>';
//print_r($query);
echo '</pre>';

			}
		}
		
		
		
		//удалить все сообщения
		$query = array(
			'DELETE'	=> 'posts',
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_phpbb['result']['posts'] = 0;
		foreach ($phpbb_posts as $posts)
		{
			$query = array(
				'SELECT'	=> 'id',
				'FROM'		=> 'posts',
				'WHERE'		=> 'id='.$posts['post_id']
			);
			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$cur_pid = $forum_db->fetch_assoc($result);
			
			if (count($cur_pid) < 1)
			{
				$query = array(
					'SELECT'	=> 'id, username',
					'FROM'		=> 'users',
					'WHERE'		=> 'id='.$posts['poster_id']
				);
				$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
				$user_info = $forum_db->fetch_assoc($result);
				
				$poster = !empty($posts['post_username']) ? $posts['post_username'] : $user_info['username'];
				
				// Add the post
				$query = array(
					'INSERT'	=> 'id, poster, poster_id, poster_ip, message, hide_smilies, posted, topic_id',
					'INTO'		=> 'posts',
					'VALUES'	=> ''.$posts['post_id'].', \''.$forum_db->escape($poster).'\', '.$user_info['id'].', \''.$forum_db->escape($posts['poster_ip']).'\', \''.$forum_db->escape($posts['post_text']).'\', '.$posts['enable_smilies'].', '.$posts['post_time'].', '.$posts['topic_id']
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);

				$forum_phpbb['result']['posts']++;
echo '<pre>';
//print_r($query);
echo '</pre>';

			}
		}
		
		//удалить все topics
		$query = array(
			'DELETE'	=> 'topics',
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_phpbb['result']['topics'] = 0;
		foreach ($phpbb_topics as $topics)
		{
			$query = array(
				'SELECT'	=> 'id',
				'FROM'		=> 'topics',
				'WHERE'		=> 'id='.$topics['topic_id']
			);
			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$cur_tid = $forum_db->fetch_assoc($result);
			
			if (count($cur_tid) < 1)
			{
				$query = array(
					'SELECT'	=> 'id, username',
					'FROM'		=> 'users',
					'WHERE'		=> 'id='.$topics['topic_poster']
				);
				$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
				$user_info = $forum_db->fetch_assoc($result);
				
				// Add the topic
				$query = array(
					'INSERT'	=> 'id, poster, subject, posted, first_post_id, last_post, last_post_id, last_poster, num_views, forum_id',
					'INTO'		=> 'topics',
					'VALUES'	=> ''.$topics['topic_id'].', \''.$forum_db->escape($user_info['username']).'\', \''.$forum_db->escape($topics['topic_title']).'\', '.$topics['topic_time'].', '.$topics['topic_first_post_id'].', '.$topics['topic_last_post_time'].', '.$topics['topic_last_post_id'].', \''.$forum_db->escape($topics['topic_last_poster_name']).'\', '.$topics['topic_views'].', '.$topics['forum_id']
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);

				$forum_phpbb['result']['topics']++;
echo '<pre>';
//print_r($query);
echo '</pre>';

			}
		}
		
		
		//удалить все categories
		$query = array(
			'DELETE'	=> 'categories',
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		//удалить все forums
		$query = array(
			'DELETE'	=> 'forums',
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		$forum_phpbb['result']['categories'] = 0;
		$forum_phpbb['result']['forums'] = 0;
		foreach ($phpbb_forums as $forums)
		{
			if ($forums['parent_id'] == 0)
			{
				$query = array(
					'SELECT'	=> 'id',
					'FROM'		=> 'categories',
					'WHERE'		=> 'id='.$forums['forum_id']
				);
				$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
				$cur_cid = $forum_db->fetch_assoc($result);
				
				if (count($cur_cid) < 1)
				{
					// Add the category
					$query = array(
						'INSERT'	=> 'id, cat_name, disp_position',
						'INTO'		=> 'categories',
						'VALUES'	=> ''.$forums['forum_id'].', \''.$forum_db->escape($forums['forum_name']).'\', 0'
					);
					$forum_db->query_build($query) or error(__FILE__, __LINE__);

					$forum_phpbb['result']['categories']++;
echo '<pre>';
//print_r($query);
echo '</pre>';
				}
			}
			else
			{
				$query = array(
					'SELECT'	=> 'id',
					'FROM'		=> 'forums',
					'WHERE'		=> 'id='.$forums['forum_id']
				);
				$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
				$cur_fid = $forum_db->fetch_assoc($result);
				
				if (count($cur_fid) < 1)
				{
					// Add the forum
					$query = array(
						'INSERT'	=> 'id, forum_name, forum_desc, last_post, last_post_id, last_poster, cat_id',
						'INTO'		=> 'forums',
						'VALUES'	=> ''.$forums['forum_id'].', \''.$forum_db->escape($forums['forum_name']).'\', \''.$forum_db->escape($forums['forum_desc']).'\', '.$forums['forum_last_post_time'].', '.$forums['forum_last_post_id'].', \''.$forum_db->escape($forums['forum_last_poster_name']).'\', '.$forums['parent_id']
					);
					$forum_db->query_build($query) or error(__FILE__, __LINE__);
					$new_uid = $forum_db->insert_id();
					
					$forum_phpbb['result']['forums']++;
echo '<pre>';
//print_r($query);
echo '</pre>';
					sync_forum($new_uid);
				}
			}
		}
		
		
	}
	
	$forum_flash->add_info('All tables converted');
//	redirect(forum_link($forum_url['pan_converter_section'], $section), '');
}

if (isset($_POST['delete_prefix']) )
{
	$dump_name = $_POST['dump_name'];
	$prefix = !empty($_POST['prefix']) ? '$'.$_POST['prefix'] : '';
	
	if (file_exists(FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$dump_name) && ($prefix != ''))
	{
		$dump_path = FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$dump_name;
		
		$fp = file_get_contents($dump_path);
		$fp = str_replace($prefix, '$phpbb_', $fp);
		file_put_contents($dump_path, $fp);
	}
	
	$forum_flash->add_info('Prefixes replaced');
	redirect(forum_link($forum_url['pan_converter_section'], $section), '');
}

$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array('Converter', forum_link($forum_url['pan_converter_settings'])),
	'From phpBB to PunBB'
);

define('FORUM_PAGE_SECTION', 'pan-converter');
define('FORUM_PAGE', 'admin-pan-converter-'.$section);
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();



?>

	<div class="main-content main-frm">

		<div class="content-head">
			<h2 class="hn"><span>Converting phpBB-3 to PunBB-1.4</span></h2>
		</div>

<?php
	// If there were any errors, show them
	if (!empty($errors))
	{
		$forum_page['errors'] = array();
		foreach ($errors as $cur_error)
			$forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
			
?>
		<div class="ct-box error-box">
			<h2 class="warn hn">Errors!</h2>
			<ul class="error-list">
				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
			</ul>
		</div>
<?php
	}
?>

		<div class="frm-form">
			<div class="ct-box">
				<p><strong>Notice!</strong></p>
				<p>1. Replace frefix in tables. If there was no prefix, leave this field blank and skip this step.</p>
				<p>2. Select PHP Dump file and press start button for converting.</p>
			</div>
		</div>

		<form class="frm-form" name="upload" action="<?php echo forum_link($forum_url['pan_converter_section'], $section) ?>" method="post">

			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_section'], $section)) ?>" />
			</div>

			<div class="sf-set set">
				<div class="sf-box select">
					<label for="fld">
						<span>Dump Files</span>
						<small>Select a SQL Dump as PHP Array file.</small>
					</label><br />
					<span class="fld-input"><select name="dump_name">
<?php

$available_files = pan_get_all_files(FORUM_ROOT.$forum_url['pan_converter_dumps'], array('php'));
foreach ($available_files as $sql_files) {
	echo "\t\t\t\t\t\t\t\t".'<option value="'.$sql_files.'">'.$sql_files.'</option>'."\n";
}

?>
						</select>
					</span>
				</div>
			</div>
			
			<div class="sf-set set">
				<div class="sf-box text required longtext">
					<label for="fld"><span>Prefix Tables</span><small>Enter prefix of tables selected database. If there was no prefix, leave this field blank and skip this step.</small></label><br />
					<span class="fld-input"><input type="text" name="prefix" value="" placeholder="frefix_" /></span>
				</div>
			</div>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="convert" value="Convert Now!" /></span>
				<span class="submit primary"><input type="submit" name="delete_prefix" value="Replace Prefix" /></span>
			</div>
		</form>

	</div>

<?php

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->